#!/bin/bash
#
source /etc/conf.d/vdr.admin.cfg
source /etc/conf.d/vdr

logger -s "ADMIN - GUI: $GUI"
rc-update del freevo
rc-update del xdm
rc-update del xorg

BOARD="$(/_config/bin/query_mb.sh)"

if [ "$GUI" = "FreeVo" ] ; then
   rc-update add freevo default
   sed -i /etc/conf.d/vdr.swcon -e "s/ -t .*/ -t FreeVo\"/"
#   logger -s "Untersuche Audio und Videoverzeichnis - kann lange dauern !"
#   freevo cache
elif [ "$GUI" = "KDE" ] ; then
   sed -i /etc/conf.d/vdr.swcon -e "s/ -t .*/ -t KDE\"/"
   rc-update add xdm default
elif [ "$GUI" = "Aus" ] ; then
   if [ "$BOARD" = "ACTIVY" ] && [ "$ACTIVY_OVERLAY" != "Aus" ] ; then
      rc-update add xorg default
   fi  
else
   echo "Unknown GUI parameter $1"
   exit 1
fi
if [ "$BOARD" = "ACTIVY" ] ; then
   if [ "$SCREEN_RESOLUTION" = "1024x768" ] ; then
      cp /etc/X11/xorg.conf.activy.1024 /etc/X11/xorg.conf
   else
      cp /etc/X11/xorg.conf.activy /etc/X11/xorg.conf
   fi      
fi      

depscan.sh
exit 0
