#!/usr/bin/perl
use File::Copy;

my $VDR_CONF = "/etc/conf.d/vdr";
my $ADMIN_CFGFILE = "/etc/vdr/plugins/admin/admin.conf";

# read /etc/conf.d/vdr into hash %vc
open(VDRCONF, "<$VDR_CONF") || die "$VDR_CONF nicht gefunden";
my @Lines = <VDRCONF>;
close(VDRCONF);
my %vc;
#my @NeueZeilen;
foreach $line (@Lines) {
  chomp $line;
  my @vars = split /[# ="]/, $line;

  if ($vars[0]) {
     my @vals = split /"/, $line;
     $vc{$vars[0]}=$vals[1];
     #print "<$vars[0]><$vals[1]>\n";
  }
}

# Now rewrite admin.conf
open(ADMCONF, "<$ADMIN_CFGFILE") || die "$ADMIN_CFGFILE nicht gefunden";
my @Lines = <ADMCONF>;
close(ADMCONF);

unlink( "$ADMIN_CFGFILE.save");
rename( $ADMIN_CFGFILE, "$ADMIN_CFGFILE.save");

if (!open(ADMCONF, ">$ADMIN_CFGFILE")) {
   rename( "$ADMIN_CFGFILE.save", $ADMIN_CFGFILE);
   die "$ADMIN_CFGFILE kann nicht erstellt werden";
}

#my @NeueZeilen;
foreach $line (@Lines) {
  chomp $line;
  my $newline = $line;
  if (index($line, "/") == 0) {
     my @vars = split /:/, $line;

     if ($vars[1] && ($vars[1] !~ /^PLG_.*/) && ($vars[1] !~ /^UPD_.*/) ) {
        if (exists $vc{$vars[1]}) {
           my $newval = $vc{$vars[1]};
           my $oldval = $vars[2];
           my $defval = $vars[4];
           my $err = 0; 
           if ($vars[3] eq "L" ) {
              my @vals = split /,/, $vars[5];
              my $i = 0;
              my $found = 0;
              foreach $val (@vals) {
                 if ($val =~ /$newval/) {
                    $found = 1;
                    last;
                 }
                 if ($i == $oldval) {
                    $defval = $val;
                 }
                 $i++;
              }
              if ($found == 1) {
   #              print "$vars[1]-$vv-$vals[$vars[2]]-$i-$vars[2]\n";
                 $newval = $i;
              }
              else {
                 Logger( "<$newval> is invalid for $vars[1]" );
                 $err = 1;
              }
           }
           elsif ( $vars[3] eq "A" || $vars[3] eq "F" ) {
              if( length($newval) > $vars[4] ) {
                 Logger( "<$newval> is too long for $vars[1]" );
                 $defval = $oldval;
                 $err = 1;
              }
              else {
                 if ( $vars[5] eq "-d" ) {
                    if ( ! -d $newval ) {
                       Logger( "<$newval> does not exist ( $vars[1] )" );
                       $defval = $oldval;
                       $err = 1;
                    }
                 }
                 elsif ( $vars[5] eq "-f" ) {
                    if ( ! -f $newval ) {
                       Logger( "<$newval> does not exist ( $vars[1] )" );
                       $defval = $oldval;
                       $err = 1;
                    }
                 }
                 elsif ( $vars[5] eq "-D" || $vars[5] eq "-F"  ) {
                    if ( substr( $newval, 0, 1 ) ne "/" ) {
                       Logger( "<$newval> is invalid for $vars[1]" );
                       $defval = $oldval;
                       $err = 1;
                    }
                 }
                 else {
                    if ( $newval !~ /^[$vars[5]]*$/ ) {
                       Logger( "<$newval> is invalid for $vars[1]" );
                       $defval = $oldval;
                       $err = 1;
                    }
                 }
              }
           }
           elsif ( $vars[3] eq "B" ) {
              if( $newval ne "0" && $newval ne "1" ) {
                 Logger( "<$newval> is invalid for $vars[1]" );
                 $defval = $oldval;
                 $err = 1;
              }
           }
           elsif ( $vars[3] eq "I" ) {
              my @vals = split /,/, $vars[5];
              if( $newval < $vals[0] || $newval > $vals[1] ) {
                 Logger( "<$newval> is invalid for $vars[1]" );
                 $defval = $oldval;
                 $err = 1;
              }
           }
           else {
              $err = 1;
              Logger( "Invalid type: <$vars[3]> for $vars[1]" );
           }
           if ( $err == 1 ) {
              Logger( "Resetting $vars[1] to <$defval>" );
              system( "sed -i $VDR_CONF -e 's/^$vars[1]=.*/$vars[1]=\"$defval\"/'" );
           }
           elsif ($newval ne $oldval) {
              Logger( "$vars[1] - Neu:<$newval> Alt:<$oldval>" );
              $newline = "$vars[0]:$vars[1]:$newval:$vars[3]:$vars[4]:$vars[5]:$vars[6]:";
              #print "$newline\n";
           }
           delete $vc{$vars[1]};
        }
        else {
           Logger( "No value for <$vars[1]>" );
        }
     }
  }

  if ($newline) {
     print ADMCONF "$newline\n"; 
  }
}
close(ADMCONF);

# set the plugins
system( "perl /etc/vdr/plugins/admin/cfgplg.pl $vc{\"PLUGINS\"}" );
delete $vc{"PLUGINS"};

foreach $value (keys %vc)
{
  Logger( "<$value> not in $ADMIN_CFGFILE." );
}

# set the update
system( "sh /etc/vdr/plugins/admin/cfgupd.sh" );

exit;

sub Logger
{
   my $message = shift;
   system( "logger -s \"$message\"" );
}


